

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Diagnostics
Imports System.IO
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms.Grid.Grouping
Imports Syncfusion.Grouping



'/ <summary>
'/ Summary description for Form1.
'/ </summary>

Public Class Form1
    Inherits System.Windows.Forms.Form
    '/ <summary>
    '/ Required designer variable.
    '/ </summary>
    Private components As System.ComponentModel.Container = Nothing
    Friend timer As Timer
    Private table As DataTable
    Private gridGroupingControl1 As GridGroupingControl
    Private rand As System.Random
    Private m_numUpdatesPerTick As Integer = 10
    Private ds As DataSet

    Private toggleInsertRemove As Integer = 10 ' toggle between inserting and removing after n inserts/n removals.
    Private insertRemoveModulus As Integer = 5 ' frequency of insert / remove : every n timer ticks
    Private initialRowCount As Integer = 100
    Private panel1 As System.Windows.Forms.Panel
    Private label1 As System.Windows.Forms.Label
    Private WithEvents checkBoxFilter As System.Windows.Forms.CheckBox
    Private textBoxFilter As System.Windows.Forms.TextBox
    Private WithEvents checkBoxGrouping As System.Windows.Forms.CheckBox
    Private WithEvents buttonApplyFilter As System.Windows.Forms.Button
    Private labelTimerInterval As System.Windows.Forms.Label
    Private WithEvents trackBarTimer As System.Windows.Forms.TrackBar
    Private WithEvents checkBoxSorting As System.Windows.Forms.CheckBox
    Private WithEvents checkBoxColor As System.Windows.Forms.CheckBox
    Private panel2 As System.Windows.Forms.Panel
    Private button2 As System.Windows.Forms.Button
    Private checkBox1 As System.Windows.Forms.CheckBox
    Private textBox1 As System.Windows.Forms.TextBox
    Private checkBox2 As System.Windows.Forms.CheckBox
    Private label2 As System.Windows.Forms.Label
    Private label3 As System.Windows.Forms.Label
    Private trackBar1 As System.Windows.Forms.TrackBar
    Private checkBox3 As System.Windows.Forms.CheckBox
    Private checkBox4 As System.Windows.Forms.CheckBox
    Private label4 As System.Windows.Forms.Label
    Private WithEvents trackBarBlinkFrequency As System.Windows.Forms.TrackBar
    Private labelBlinkTime As System.Windows.Forms.Label

    ' Alter this integer to change the type of test
    Private insertRemoveCount As Integer = 2
    ' use 1 if you want to check out inserting and removing rows
    Public Sub New()
        '
        ' Required for Windows Form Designer support
        '
        InitializeComponent()

        ' Form settings
        Dim ico As New System.Drawing.Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"))
        Me.Icon = ico
        Me.Size = New Size(800, 600)

        ' Setup the grid
        gridGroupingControl1 = New GridGroupingControl
        gridGroupingControl1.VerticalThumbTrack = True
        gridGroupingControl1.HorizontalThumbTrack = True
        gridGroupingControl1.TableOptions.VerticalPixelScroll = True
        gridGroupingControl1.Location = New Point(0, 0)
        gridGroupingControl1.Size = New Size(Me.ClientSize.Width, Me.panel1.Top)
        gridGroupingControl1.Anchor = AnchorStyles.Left Or AnchorStyles.Top Or AnchorStyles.Right Or AnchorStyles.Bottom
        Me.Controls.Add(gridGroupingControl1)

        gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended

        OptimizeGrid()

        gridGroupingControl1.AllowSwapDataViewWithDataTableList = False ' we want to use "InsertAt" logice with .NET 2.0 ...
        ' Setup datatable with random data
        InitializeDataTable()
        gridGroupingControl1.DataSource = table

        ' Highlight up and downticks
        gridGroupingControl1.BlinkTime = 700 ' in ms
        Dim i As Integer
        For i = 1 To 20
            gridGroupingControl1.TableDescriptor.Columns(i.ToString()).AllowBlink = True
        Next i
        gridGroupingControl1.Engine.AddBaseStylesForBlinking()

        'gridGroupingControl1.BaseStyles[GridEngine.BlinkIncreased].StyleInfo.Font.Bold = true;
        gridGroupingControl1.BaseStyles(GridEngine.BlinkIncreased).StyleInfo.TextColor = Color.White

        'gridGroupingControl1.BaseStyles[GridEngine.BlinkIncreased].StyleInfo.Font.Bold = true;
        gridGroupingControl1.BaseStyles(GridEngine.BlinkReduced).StyleInfo.TextColor = Color.White

        gridGroupingControl1.Engine.BaseStyles.Add("CustomStyle")
        'gridGroupingControl1.BaseStyles["CustomStyle"].StyleInfo.Font.Bold = true;
        gridGroupingControl1.BaseStyles("CustomStyle").StyleInfo.TextColor = Color.Black
        gridGroupingControl1.BaseStyles("CustomStyle").StyleInfo.BackColor = Color.White

        AddHandler Me.gridGroupingControl1.TableControlPrepareViewStyleInfo, AddressOf gridGroupingControl1_TableControlPrepareViewStyleInfo

        gridGroupingControl1.TableDescriptor.Columns(0).MaxLength = 8
        gridGroupingControl1.TableDescriptor.Columns(5).MaxLength = 6
        gridGroupingControl1.TableDescriptor.Columns(9).MaxLength = 5
        gridGroupingControl1.TableDescriptor.Columns(14).MaxLength = 6
        gridGroupingControl1.TableDescriptor.Columns("1").MaxLength = 8

        ' Sort by column "1"
        gridGroupingControl1.TableDescriptor.SortedColumns.Add("1")

        'Optional: Filter records
        'gridGroupingControl1.TableDescriptor.RecordFilters.Add("[2] > 88");
        Console.WriteLine(gridGroupingControl1.TableDescriptor.Columns("1").MaxLength)

        Me.textBoxFilter.Text = "[2] > 88"
        AddHandler Me.gridGroupingControl1.PropertyChanged, AddressOf gridGroupingControl1_PropertyChanged
        Me.gridGroupingControl1.ShowGroupDropArea = True

        ' this.gridGroupingControl1.TableControl.EnableDoubleBufferSurface();
        ' Timer
        SetupTimer()
    End Sub 'New


    Sub gridGroupingControl1_TableControlPrepareViewStyleInfo(ByVal sender As Object, ByVal e As GridTableControlPrepareViewStyleInfoEventArgs)
        Dim style As GridTableCellStyleInfo = CType(e.Inner.Style, GridTableCellStyleInfo)
        Dim bs As BlinkState = gridGroupingControl1.GetBlinkState(style.TableCellIdentity)

        If bs <> BlinkState.None Then
            If bs = BlinkState.NewRecord Then
                e.Inner.Style.BaseStyle = "CustomStyle"
            End If 'e.Inner.Style.BackColor = Color.White;
        End If 'e.Inner.Style.TextColor = Color.Black;
    End Sub 'gridGroupingControl1_TableControlPrepareViewStyleInfo


    Private Sub OptimizeGrid()
        ' Optimize memory footprint, drawing and ListChanged performance
        ' Use less memory for internal binary tree structures
        gridGroupingControl1.CounterLogic = EngineCounters.YAmount
        gridGroupingControl1.AllowedOptimizations = EngineOptimizations.DisableCounters Or EngineOptimizations.RecordsAsDisplayElements

        ' Affected settings by UseDefaultsForFasterDrawing are: InvalidateAllWhenListChanged, 
        ' TableOptions.ColumnsMaxLengthStrategy, TableOptions.GridLineBorder, 
        ' TableOptions.DrawTextWithGdiInterop, TableOptions.VerticalPixelScroll,
        ' Appearance.AnyRecordFieldCell.WrapText and Appearance.AnyRecordFieldCell.Trimming.
        gridGroupingControl1.UseDefaultsForFasterDrawing = True

        ' Instruct grouping control not to access datasource through
        ' CurrencyManager API and instead access list diretly. When set to
        ' false you wil however loose support for built-in CurrencyManager 
        ' synchronization, so only do this if you don't need CurrencyManager synchronization.
        gridGroupingControl1.BindToCurrencyManager = False

        ' Update display with changes, optionally use ScrollWindow for insert and removing rows.
        'gridGroupingControl1.UpdateDisplayFrequency = 0;  // only manual updates (when you call grid.Update)
        gridGroupingControl1.UpdateDisplayFrequency = 1 ' immediate update after each ListChanged.
        'gridGroupingControl1.UpdateDisplayFrequency = 100;  // update every 100 ms.
        gridGroupingControl1.InsertRemoveBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate ' Scrollwindow will cause immediate update.
        gridGroupingControl1.SortPositionChangedBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate ' Scrollwindow will cause immediate update.
        ' Don't forget this property. If it is true then InsertRemoveBehavior and SortPositionChangedBehavior
        ' properties would have no effect at all. Its default value is false if UseDefaultsForFasterDrawing = true
        ' has been set, but setting it explictly makes sure this is false.
        gridGroupingControl1.InvalidateAllWhenListChanged = False
    End Sub 'OptimizeGrid


    Private Sub SetupTimer()
        timer = New Timer
        AddHandler timer.Tick, AddressOf timer_Tick
        timer.Interval = 100
        timer.Start()

        Me.UpdateDialog()

        Me.gridGroupingControl1.Focus()
    End Sub 'SetupTimer


    Sub InitializeDataTable()
        ds = New DataSet
        table = New DataTable("RandomData")
        table.Columns.Add("Product", GetType(String))
        table.Columns.Add("1", GetType(System.Double))
        table.Columns.Add("2", GetType(System.Double))
        table.Columns.Add("3", GetType(System.Double))
        table.Columns.Add("4", GetType(System.Double))
        table.Columns.Add("5", GetType(System.Double))
        table.Columns.Add("6", GetType(System.Double))
        table.Columns.Add("7", GetType(System.Double))
        table.Columns.Add("8", GetType(System.Double))
        table.Columns.Add("9", GetType(System.Double))
        table.Columns.Add("10", GetType(System.Double))
        table.Columns.Add("11", GetType(System.Double))
        table.Columns.Add("12", GetType(System.Double))
        table.Columns.Add("13", GetType(System.Double))
        table.Columns.Add("14", GetType(System.Double))
        table.Columns.Add("15", GetType(System.Double))
        table.Columns.Add("16", GetType(System.Double))
        table.Columns.Add("17", GetType(System.Double))
        table.Columns.Add("18", GetType(System.Double))
        table.Columns.Add("19", GetType(System.Double))
        table.Columns.Add("20", GetType(System.Double))
        ds.Tables.Add(table)

        rand = New Random(0)

        Dim i As Integer
        For i = 0 To initialRowCount - 1
            Dim [next] As Integer = rand.Next(100)
            table.Rows.Add(New Object() {"P" + i.ToString("00000"), [next] + 1, [next] + 2, [next] + 3, [next] + 4, [next] + 5, [next] + 6, [next] + 7, [next] + 8, [next] + 9, [next] + 10, [next] + 11, [next] + 12, [next] + 13, [next] + 14, [next] + 15, [next] + 16, [next] + 17, [next] + 18, [next] + 19, [next] + 20})
        Next i
    End Sub 'InitializeDataTable



    Sub gridGroupingControl1_QueryCellStyleInfo(ByVal sender As Object, ByVal e As GridTableCellStyleInfoEventArgs)
        Dim style As GridTableCellStyleInfo = CType(e.Style, GridTableCellStyleInfo)
        If e.TableCellIdentity.TableCellType = GridTableCellType.RecordFieldCell OrElse e.TableCellIdentity.TableCellType = GridTableCellType.AlternateRecordFieldCell Then
            'if (this.gridGroupingControl1.GetBlinkState(e.TableCellIdentity) == BlinkState.NewRecord)
            '{
            '    e.Style.BaseStyle = "CustomStyle";
            '    e.Style.TextColor = Color.Yellow;
            '}
            If e.TableCellIdentity.Column.FieldDescriptor.FieldPropertyType Is GetType(String) Then
                Return
            End If
            'if (this.gridGroupingControl1.GetBlinkState(e.TableCellIdentity) == BlinkState.None)
            If (True) Then
                ' Get the value from column "1" and color all cells in record based
                ' on this value.
                Dim r As Record = e.Style.TableCellIdentity.DisplayElement.GetRecord()
                Dim value As Object = r.GetValue("1")
                Dim v As Integer = Convert.ToInt32(value) Mod colors.Length
                e.Style.BackColor = colors(v)
            End If
        End If
    End Sub 'gridGroupingControl1_QueryCellStyleInfo


    '/ <summary>
    '/ Clean up any resources being used.
    '/ </summary>
    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose

#Region "Windows Form Designer generated code"

    '/ <summary>
    '/ Required method for Designer support - do not modify
    '/ the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Me.panel1 = New System.Windows.Forms.Panel
        Me.buttonApplyFilter = New System.Windows.Forms.Button
        Me.checkBoxGrouping = New System.Windows.Forms.CheckBox
        Me.textBoxFilter = New System.Windows.Forms.TextBox
        Me.checkBoxFilter = New System.Windows.Forms.CheckBox
        Me.labelTimerInterval = New System.Windows.Forms.Label
        Me.label1 = New System.Windows.Forms.Label
        Me.trackBarTimer = New System.Windows.Forms.TrackBar
        Me.checkBoxSorting = New System.Windows.Forms.CheckBox
        Me.checkBoxColor = New System.Windows.Forms.CheckBox
        Me.label4 = New System.Windows.Forms.Label
        Me.trackBarBlinkFrequency = New System.Windows.Forms.TrackBar
        Me.labelBlinkTime = New System.Windows.Forms.Label
        Me.panel2 = New System.Windows.Forms.Panel
        Me.button2 = New System.Windows.Forms.Button
        Me.checkBox1 = New System.Windows.Forms.CheckBox
        Me.textBox1 = New System.Windows.Forms.TextBox
        Me.checkBox2 = New System.Windows.Forms.CheckBox
        Me.label2 = New System.Windows.Forms.Label
        Me.label3 = New System.Windows.Forms.Label
        Me.trackBar1 = New System.Windows.Forms.TrackBar
        Me.checkBox3 = New System.Windows.Forms.CheckBox
        Me.checkBox4 = New System.Windows.Forms.CheckBox
        Me.panel1.SuspendLayout()
        CType(Me.trackBarTimer, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.trackBarBlinkFrequency, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.panel2.SuspendLayout()
        CType(Me.trackBar1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        ' 
        ' panel1
        ' 
        Me.panel1.Anchor = CType(System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right, System.Windows.Forms.AnchorStyles)
        Me.panel1.Controls.Add(Me.buttonApplyFilter)
        Me.panel1.Controls.Add(Me.checkBoxGrouping)
        Me.panel1.Controls.Add(Me.textBoxFilter)
        Me.panel1.Controls.Add(Me.checkBoxFilter)
        Me.panel1.Controls.Add(Me.labelTimerInterval)
        Me.panel1.Controls.Add(Me.label1)
        Me.panel1.Controls.Add(Me.trackBarTimer)
        Me.panel1.Controls.Add(Me.checkBoxSorting)
        Me.panel1.Controls.Add(Me.checkBoxColor)
        Me.panel1.Controls.Add(Me.label4)
        Me.panel1.Controls.Add(Me.trackBarBlinkFrequency)
        Me.panel1.Controls.Add(Me.labelBlinkTime)
        Me.panel1.Location = New System.Drawing.Point(-8, 368)
        Me.panel1.Name = "panel1"
        Me.panel1.Size = New System.Drawing.Size(704, 184)
        Me.panel1.TabIndex = 0
        ' 
        ' buttonApplyFilter
        ' 
        Me.buttonApplyFilter.Location = New System.Drawing.Point(400, 56)
        Me.buttonApplyFilter.Name = "buttonApplyFilter"
        Me.buttonApplyFilter.Size = New System.Drawing.Size(80, 24)
        Me.buttonApplyFilter.TabIndex = 8
        Me.buttonApplyFilter.Text = "Apply"
        ' 
        ' checkBoxGrouping
        ' 
        Me.checkBoxGrouping.Location = New System.Drawing.Point(32, 96)
        Me.checkBoxGrouping.Name = "checkBoxGrouping"
        Me.checkBoxGrouping.Size = New System.Drawing.Size(112, 24)
        Me.checkBoxGrouping.TabIndex = 7
        Me.checkBoxGrouping.Text = "Enable Grouping"
        ' 
        ' textBoxFilter
        ' 
        Me.textBoxFilter.Location = New System.Drawing.Point(160, 56)
        Me.textBoxFilter.Name = "textBoxFilter"
        Me.textBoxFilter.Size = New System.Drawing.Size(216, 20)
        Me.textBoxFilter.TabIndex = 6
        Me.textBoxFilter.Text = "textBox1"
        ' 
        ' checkBoxFilter
        ' 
        Me.checkBoxFilter.Location = New System.Drawing.Point(32, 56)
        Me.checkBoxFilter.Name = "checkBoxFilter"
        Me.checkBoxFilter.Size = New System.Drawing.Size(96, 24)
        Me.checkBoxFilter.TabIndex = 5
        Me.checkBoxFilter.Text = "Enable Filter"
        ' 
        ' labelTimerInterval
        ' 
        Me.labelTimerInterval.Location = New System.Drawing.Point(368, 8)
        Me.labelTimerInterval.Name = "labelTimerInterval"
        Me.labelTimerInterval.Size = New System.Drawing.Size(112, 40)
        Me.labelTimerInterval.TabIndex = 4
        Me.labelTimerInterval.Text = "label2"
        ' 
        ' label1
        ' 
        Me.label1.Font = New System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, System.Byte))
        Me.label1.Location = New System.Drawing.Point(8, 8)
        Me.label1.Name = "label1"
        Me.label1.Size = New System.Drawing.Size(152, 48)
        Me.label1.TabIndex = 3
        Me.label1.Text = "Timer Frequency"
        Me.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        ' 
        ' trackBarTimer
        ' 
        Me.trackBarTimer.Location = New System.Drawing.Point(160, 8)
        Me.trackBarTimer.Name = "trackBarTimer"
        Me.trackBarTimer.Size = New System.Drawing.Size(184, 50)
        Me.trackBarTimer.TabIndex = 2
        ' 
        ' checkBoxSorting
        ' 
        Me.checkBoxSorting.Location = New System.Drawing.Point(160, 96)
        Me.checkBoxSorting.Name = "checkBoxSorting"
        Me.checkBoxSorting.Size = New System.Drawing.Size(112, 24)
        Me.checkBoxSorting.TabIndex = 7
        Me.checkBoxSorting.Text = "Enable Sorting"
        ' 
        ' checkBoxColor
        ' 
        Me.checkBoxColor.Location = New System.Drawing.Point(296, 96)
        Me.checkBoxColor.Name = "checkBoxColor"
        Me.checkBoxColor.Size = New System.Drawing.Size(112, 24)
        Me.checkBoxColor.TabIndex = 7
        Me.checkBoxColor.Text = "Enable Coloring"
        ' 
        ' label4
        ' 
        Me.label4.Font = New System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, System.Byte))
        Me.label4.Location = New System.Drawing.Point(8, 136)
        Me.label4.Name = "label4"
        Me.label4.Size = New System.Drawing.Size(152, 48)
        Me.label4.TabIndex = 3
        Me.label4.Text = "Blink Frequency"
        Me.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        ' 
        ' trackBarBlinkFrequency
        ' 
        Me.trackBarBlinkFrequency.Location = New System.Drawing.Point(160, 136)
        Me.trackBarBlinkFrequency.Maximum = 20
        Me.trackBarBlinkFrequency.Name = "trackBarBlinkFrequency"
        Me.trackBarBlinkFrequency.Size = New System.Drawing.Size(184, 50)
        Me.trackBarBlinkFrequency.SmallChange = 2
        Me.trackBarBlinkFrequency.TabIndex = 2
        Me.trackBarBlinkFrequency.TickFrequency = 2
        ' 
        ' labelBlinkTime
        ' 
        Me.labelBlinkTime.Location = New System.Drawing.Point(368, 136)
        Me.labelBlinkTime.Name = "labelBlinkTime"
        Me.labelBlinkTime.Size = New System.Drawing.Size(112, 40)
        Me.labelBlinkTime.TabIndex = 4
        Me.labelBlinkTime.Text = "Disabled."
        ' 
        ' panel2
        ' 
        Me.panel2.Anchor = CType(System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right, System.Windows.Forms.AnchorStyles)
        Me.panel2.Controls.Add(Me.button2)
        Me.panel2.Controls.Add(Me.checkBox1)
        Me.panel2.Controls.Add(Me.textBox1)
        Me.panel2.Controls.Add(Me.checkBox2)
        Me.panel2.Controls.Add(Me.label2)
        Me.panel2.Controls.Add(Me.label3)
        Me.panel2.Controls.Add(Me.trackBar1)
        Me.panel2.Controls.Add(Me.checkBox3)
        Me.panel2.Controls.Add(Me.checkBox4)
        Me.panel2.Location = New System.Drawing.Point(-8, 416)
        Me.panel2.Name = "panel2"
        Me.panel2.Size = New System.Drawing.Size(704, 216)
        Me.panel2.TabIndex = 0
        ' 
        ' button2
        ' 
        Me.button2.Location = New System.Drawing.Point(504, 56)
        Me.button2.Name = "button2"
        Me.button2.Size = New System.Drawing.Size(80, 24)
        Me.button2.TabIndex = 8
        Me.button2.Text = "Apply"
        ' 
        ' checkBox1
        ' 
        Me.checkBox1.Location = New System.Drawing.Point(32, 88)
        Me.checkBox1.Name = "checkBox1"
        Me.checkBox1.Size = New System.Drawing.Size(112, 24)
        Me.checkBox1.TabIndex = 7
        Me.checkBox1.Text = "Enable Grouping"
        ' 
        ' textBox1
        ' 
        Me.textBox1.Location = New System.Drawing.Point(160, 56)
        Me.textBox1.Name = "textBox1"
        Me.textBox1.Size = New System.Drawing.Size(320, 20)
        Me.textBox1.TabIndex = 6
        Me.textBox1.Text = "textBox1"
        ' 
        ' checkBox2
        ' 
        Me.checkBox2.Location = New System.Drawing.Point(32, 56)
        Me.checkBox2.Name = "checkBox2"
        Me.checkBox2.Size = New System.Drawing.Size(96, 24)
        Me.checkBox2.TabIndex = 5
        Me.checkBox2.Text = "Enable Filter"
        ' 
        ' label2
        ' 
        Me.label2.Location = New System.Drawing.Point(368, 8)
        Me.label2.Name = "label2"
        Me.label2.Size = New System.Drawing.Size(112, 40)
        Me.label2.TabIndex = 4
        Me.label2.Text = "label2"
        ' 
        ' label3
        ' 
        Me.label3.Font = New System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, System.Byte))
        Me.label3.Location = New System.Drawing.Point(8, 8)
        Me.label3.Name = "label3"
        Me.label3.Size = New System.Drawing.Size(152, 48)
        Me.label3.TabIndex = 3
        Me.label3.Text = "Timer Frequency"
        Me.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        ' 
        ' trackBar1
        ' 
        Me.trackBar1.Location = New System.Drawing.Point(160, 8)
        Me.trackBar1.Name = "trackBar1"
        Me.trackBar1.Size = New System.Drawing.Size(184, 50)
        Me.trackBar1.TabIndex = 2
        ' 
        ' checkBox3
        ' 
        Me.checkBox3.Location = New System.Drawing.Point(160, 88)
        Me.checkBox3.Name = "checkBox3"
        Me.checkBox3.Size = New System.Drawing.Size(112, 24)
        Me.checkBox3.TabIndex = 7
        Me.checkBox3.Text = "Enable Sorting"
        ' 
        ' checkBox4
        ' 
        Me.checkBox4.Location = New System.Drawing.Point(296, 88)
        Me.checkBox4.Name = "checkBox4"
        Me.checkBox4.Size = New System.Drawing.Size(112, 24)
        Me.checkBox4.TabIndex = 7
        Me.checkBox4.Text = "Enable Coloring"
        ' 
        ' Form1
        ' 
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(696, 546)
        Me.Controls.Add(panel1)
        Me.Controls.Add(panel2)
        Me.Name = "Form1"
        Me.Text = "TraderGridTest..."
        Me.panel1.ResumeLayout(False)
        CType(Me.trackBarTimer, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.trackBarBlinkFrequency, System.ComponentModel.ISupportInitialize).EndInit()
        Me.panel2.ResumeLayout(False)
        CType(Me.trackBar1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
    End Sub 'InitializeComponent 
#End Region


    '/ <summary>
    '/ The main entry point for the application.
    '/ </summary>
    <STAThread()> _
    Shared Sub Main()
        Application.Run(New Form1)
    End Sub 'Main

    Private icount As Integer = 0
    Private timerCount As Integer = 0
    Private ti As Integer = 0
    Private shouldInsert As Boolean = False
    Private waitKey As Boolean = False


    Sub WaitForKey()
        skipTimer = True
        RemoveHandler timer.Tick, AddressOf timer_Tick
        timer.Enabled = False
        Application.DoEvents()
        If Control.ModifierKeys = Keys.Shift Then
            waitKey = True
        End If
        If waitKey Then
            While Control.ModifierKeys = Keys.None
                System.Threading.Thread.Sleep(5)
                Application.DoEvents()
            End While
        End If
        If Not Visible Then
            Application.Exit()
        End If
        AddHandler timer.Tick, AddressOf timer_Tick
        timer.Enabled = True
        skipTimer = False
    End Sub 'WaitForKey

    Private skipTimer As Boolean = False


    Private Sub timer_Tick(ByVal sender As Object, ByVal e As EventArgs)
        If skipTimer Then
            Return
        End If
        timerCount += 1

        Try
            Dim i As Integer
            For i = 0 To m_numUpdatesPerTick - 1
                '  Application.DoEvents();
                Dim recNum As Integer = rand.Next(table.Rows.Count - 1)
                Dim rowNum As Integer = recNum + 1
                Dim col As Integer = rand.Next(16) + 1
                Dim colNum As Integer = col + 1
                Dim drow As DataRow = table.Rows(recNum)
                If Not TypeOf drow(col) Is DBNull Then
                    drow(col) = CInt(Convert.ToDouble(drow(col)) * (rand.Next(50) / 100.0F + 0.8)) ' rand.Next(100);
                End If 'drow[col] = (int) rand.Next(16) + 18; //(Convert.ToDouble(drow[col]) * (rand.Next(50) / 100.0f + 0.8));// rand.Next(100);
            Next i '					            if (timerCount % 2 == 1)
            '									drow[col] = 24;//(int) (Convert.ToDouble(drow[col]) * (rand.Next(50) / 100.0f + 0.8));// rand.Next(100);
            '										else
            '									drow[col] = 2;

            ' System.Threading.Thread.Sleep(300);
            ' Insert or remove a row
            If insertRemoveCount = 0 Then
                Return
            End If
            If toggleInsertRemove > 0 AndAlso timerCount Mod insertRemoveModulus = 0 Then
                icount = icount + 1
                icount = icount Mod toggleInsertRemove * 2
                shouldInsert = icount < toggleInsertRemove

                If shouldInsert Then
                    Dim ri As Integer
                    For ri = 0 To insertRemoveCount - 1
                        Dim recNum As Integer = 5 ' rand.Next(table.Rows.Count - 1);
                        Dim [next] As Integer = rand.Next(100)
                        Dim row() As Object = {"H" + ti.ToString("00000"), [next] + 1, [next] + 2, [next] + 3, [next] + 4, [next] + 5, [next] + 6, [next] + 7, [next] + 8, [next] + 9, [next] + 10, [next] + 11, [next] + 12, [next] + 13, [next] + 14, [next] + 15, [next] + 16, [next] + 17, [next] + 18, [next] + 19, [next] + 20}
                        ti += 1
                        Dim drow As DataRow = table.NewRow()
                        drow.ItemArray = row
                        table.Rows.InsertAt(drow, recNum)
                    Next ri 'table.Rows.Add(drow);
                Else
                    Dim ri As Integer
                    For ri = 0 To insertRemoveCount - 1
                        Dim recNum As Integer = 5 'rand.Next(m_set.Count - 1);
                        Dim rowNum As Integer = recNum + 1

                        ' Underlying data structure (this could be a datatable or whatever structure
                        ' you use behind a virtual grid).
                        If table.Rows.Count > 10 Then
                            table.Rows.RemoveAt(recNum)
                        End If
                    Next ri
                End If
            End If
        Finally
        End Try
    End Sub 'timer_Tick

    Private colors() As Color = {Color.FromArgb(&H85, &HBF, &H75), Color.FromArgb(&HB4, &HE7, &HF2), Color.FromArgb(&HFF, &HBF, &H34), Color.FromArgb(&H82, &H2E, &H1B), Color.FromArgb(&H3A, &H86, &H7E)}


    'Color.FromArgb( 0xde, 0x64, 0x13 ),

    Private Sub trackBarTimer_Scroll(ByVal sender As Object, ByVal e As System.EventArgs) Handles trackBarTimer.Scroll
        If Me.trackBarTimer.Value = 0 Then
            timer.Enabled = False
            Me.labelTimerInterval.Text = String.Format("Timer disabled.")
        Else
            timer.Interval = 1000 / (Me.trackBarTimer.Value * trackBarTimer.Value)
            timer.Enabled = True
            Me.labelTimerInterval.Text = String.Format("Every {0} milliseconds.", timer.Interval)
        End If
    End Sub 'trackBarTimer_Scroll

#Region "Update dialog controls with changes to grid"

    Private Sub gridGroupingControl1_PropertyChanged(ByVal sender As Object, ByVal e As DescriptorPropertyChangedEventArgs)
        UpdateDialog()
    End Sub 'gridGroupingControl1_PropertyChanged


    Private Sub UpdateDialog()
        If isUIChanged Then
            Return
        End If
        Try
            isPropertyChanged = True

            Dim td As GridTableDescriptor = Me.gridGroupingControl1.TableDescriptor

            Me.checkBoxFilter.Checked = td.RecordFilters.Count > 0
            If td.RecordFilters.Count > 0 Then
                Me.textBoxFilter.Text = td.RecordFilters(0).Expression
            End If
            Me.checkBoxGrouping.Checked = td.GroupedColumns.Count > 0
            Me.checkBoxSorting.Checked = td.SortedColumns.Count > 0

            Me.trackBarBlinkFrequency.Value = Me.gridGroupingControl1.BlinkTime / 100
            If Me.gridGroupingControl1.BlinkTime = 0 Then
                Me.labelBlinkTime.Text = String.Format("Disabled.")
            Else
                Me.labelBlinkTime.Text = String.Format("{0} milliseconds.", gridGroupingControl1.BlinkTime)
            End If
            If Not (timer Is Nothing) Then
                If timer.Enabled Then
                    trackBarTimer.Value = CInt(Math.Sqrt(1000 / timer.Interval))
                Else
                    trackBarTimer.Value = 0
                End If
                trackBarTimer.TickFrequency = 1
                Me.labelTimerInterval.Text = String.Format("Every {0} milliseconds.", timer.Interval)
            End If
        Catch ex As Exception
            Trace.WriteLine(ex.ToString())
        Finally
            isPropertyChanged = False
        End Try
    End Sub 'UpdateDialog

    Private isUIChanged As Boolean = False
    Private isPropertyChanged As Boolean = False
#End Region
#Region "Filter"

    Private Sub checkBoxFilter_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles checkBoxFilter.CheckedChanged
        ApplyFilter()
    End Sub 'checkBoxFilter_CheckedChanged


    Private Sub buttonApplyFilter_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles buttonApplyFilter.Click
        If Not checkBoxFilter.Checked Then
            checkBoxFilter.Checked = True
        Else
            ApplyFilter()
        End If
    End Sub 'buttonApplyFilter_Click

    Private Sub ApplyFilter()
        If isPropertyChanged Then
            Return
        End If
        isUIChanged = True

        Dim td As GridTableDescriptor = Me.gridGroupingControl1.TableDescriptor
        Try
            If Me.checkBoxFilter.Checked Then
                td.RecordFilters.Clear()
                td.RecordFilters.Add(Me.textBoxFilter.Text)
            Else
                td.RecordFilters.Clear()
            End If
            Me.gridGroupingControl1.Refresh()
        Catch ex As Exception
            Trace.WriteLine(ex.ToString())
        Finally
            isUIChanged = False
        End Try
    End Sub 'ApplyFilter
#End Region
#Region "Grouping"

    Private Sub checkBoxGrouping_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles checkBoxGrouping.CheckedChanged
        If isPropertyChanged Then
            Return
        End If
        isUIChanged = True

        Dim td As GridTableDescriptor = Me.gridGroupingControl1.TableDescriptor
        Try
            If Me.checkBoxGrouping.Checked Then
                td.GroupedColumns.Clear()
                td.GroupedColumns.Add("1")
                Me.gridGroupingControl1.Table.ExpandAllGroups()
            Else
                td.GroupedColumns.Clear()
            End If
            Me.gridGroupingControl1.Refresh()
        Catch ex As Exception
            Trace.WriteLine(ex.ToString())
        Finally
            isUIChanged = False
        End Try
    End Sub 'checkBoxGrouping_CheckedChanged
#End Region
#Region "BlinkFrequency"

    Private Sub trackBarBlinkFrequency_Scroll(ByVal sender As Object, ByVal e As System.EventArgs) Handles trackBarBlinkFrequency.Scroll
        If isPropertyChanged Then
            Return
        End If
        isUIChanged = True

        Dim td As GridTableDescriptor = Me.gridGroupingControl1.TableDescriptor
        Try
            Me.gridGroupingControl1.BlinkTime = Me.trackBarBlinkFrequency.Value * 100
            If Me.gridGroupingControl1.BlinkTime = 0 Then
                Me.labelBlinkTime.Text = String.Format("Disabled.")
            Else
                Me.labelBlinkTime.Text = String.Format("{0} milliseconds.", gridGroupingControl1.BlinkTime)
            End If
            Me.gridGroupingControl1.Refresh()
        Catch ex As Exception
            Trace.WriteLine(ex.ToString())
        Finally
            isUIChanged = False
        End Try
    End Sub 'trackBarBlinkFrequency_Scroll
#End Region
#Region "Sorting"

    Private Sub checkBoxSorting_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles checkBoxSorting.CheckedChanged
        If isPropertyChanged Then
            Return
        End If
        isUIChanged = True

        Dim td As GridTableDescriptor = Me.gridGroupingControl1.TableDescriptor
        Try
            If Me.checkBoxSorting.Checked Then
                td.SortedColumns.Clear()
                td.SortedColumns.Add("1")
                td.SortedColumns.Add("2")
            Else
                td.SortedColumns.Clear()
            End If
            Me.gridGroupingControl1.Refresh()
        Catch ex As Exception
            Trace.WriteLine(ex.ToString())
        Finally
            isUIChanged = False
        End Try
    End Sub 'checkBoxSorting_CheckedChanged 
#End Region
#Region "Coloring"

    Private Sub checkBoxColor_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles checkBoxColor.CheckedChanged
        isUIChanged = True

        Dim td As GridTableDescriptor = Me.gridGroupingControl1.TableDescriptor
        Try
            If Me.checkBoxColor.Checked Then
                ' Callback for dynamically coloring cells
                AddHandler gridGroupingControl1.QueryCellStyleInfo, AddressOf gridGroupingControl1_QueryCellStyleInfo

                ' The color of these cells depends on value of cell "1". If engines ListChanged handler
                ' detects a change to column "1" it should also automatically repaint the dependant columns
                Dim i As Integer
                For i = 2 To 20
                    gridGroupingControl1.TableDescriptor.Fields(i.ToString()).ReferencedFields = "1"
                Next i
            Else
                RemoveHandler gridGroupingControl1.QueryCellStyleInfo, AddressOf gridGroupingControl1_QueryCellStyleInfo
                gridGroupingControl1.TableDescriptor.Fields.LoadDefault()
            End If
            Me.gridGroupingControl1.Refresh()
        Catch ex As Exception
            Trace.WriteLine(ex.ToString())
        Finally
            isUIChanged = False
        End Try
    End Sub 'checkBoxColor_CheckedChanged
#End Region



    Protected Overrides Sub OnLoad(ByVal e As EventArgs)
        Dim g As GridGroupingControlSchemaBrowser = New GridGroupingControlSchemaBrowser(Me.gridGroupingControl1)
        g.Show()
        MyBase.OnLoad(e)

        ' Timer
        SetupTimer()
    End Sub 'OnLoad
End Class 'Form1 
