Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Diagnostics
Imports System.Drawing
Imports System.Text
Imports System.Threading
Imports System.Windows.Forms

Imports Syncfusion.Diagnostics
Imports Syncfusion.Grouping
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms.Grid.Grouping

'Imports Syncfusion.Grouping.ManualSummaries


'/ <summary>
'/ Summary description for Form1.
'/ </summary>

Public Class Form1
    Inherits System.Windows.Forms.Form
    Private gridGroupingControl1 As SampleGridGroupingControl
    Private northwindDataSet1 As ManualTotalSummaries.DataSet1
    Private sqlSelectCommand2 As System.Data.SqlClient.SqlCommand
    Private sqlInsertCommand2 As System.Data.SqlClient.SqlCommand
    Private sqlUpdateCommand2 As System.Data.SqlClient.SqlCommand
    Private sqlDeleteCommand2 As System.Data.SqlClient.SqlCommand
    Private sqlDataAdapterOrders As System.Data.SqlClient.SqlDataAdapter
    Private sqlConnection2 As System.Data.SqlClient.SqlConnection

    Private components As System.ComponentModel.Container = Nothing


    Shared Sub New()
        GridEngineFactory.Factory = New ManualTotalSummaryEngineFactory
    End Sub 'New


    Public Sub New()
        '
        ' Required for Windows Form Designer support
        '
        InitializeComponent()

        ' ----------- Plug in Optimization here -----------------
        ' Use this code after the InitializeComponent call in your Form ctor
        ' to plugin new optimized ListChanged event handler code
        Me.gridGroupingControl1.UpdateDisplayFrequency = 0 ' 0 if manual updates only from timer_tick
        Me.gridGroupingControl1.UseDefaultsForFasterDrawing = True
        Me.gridGroupingControl1.CounterLogic = EngineCounters.YAmount
        Me.gridGroupingControl1.AllowedOptimizations = EngineOptimizations.DisableCounters Or EngineOptimizations.RecordsAsDisplayElements
        Me.gridGroupingControl1.CacheRecordValues = False

        ' Use InvalidateAll if many records change sort position during a short time 
        ' Will also help to increase UpdateDisplayFrequency then!
        'this.gridGroupingControl1.InsertRemoveBehavior = GridListChangedInsertRemoveBehavior.InvalidateAll;
        'this.gridGroupingControl1.SortPositionChangedBehavior = GridListChangedInsertRemoveBehavior.InvalidateAll;
        ' Use ScrollWithImmediateUpdate if ScrollWindow should be called to minimize painting when sort position of
        ' limited number of records is changed (see also timer_tick method, the count setting)
        Me.gridGroupingControl1.InsertRemoveBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate
        Me.gridGroupingControl1.SortPositionChangedBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate

        'this.gridGroupingControl1.UseDefaultsForFasterDrawing = false;
        'this.gridGroupingControl1.InvalidateAllWhenListChanged = false;

        ' Instruct grouping control not to access datasource through
        ' CurrencyManager API and instead access list diretly. When set to
        ' false you wil howver loose support for built-in CurrencyManager 
        ' synchronization.
        Me.gridGroupingControl1.BindToCurrencyManager = False

        '            if (typeof(object).Assembly.ImageRuntimeVersion.IndexOf("v1") == -1)
        If GetType(Object).Assembly.CodeBase.IndexOf("v1") = -1 Then
            ' .NET 2.0 gets a bit slow when subscribing to ListChanged event on the 
            ' DataTable.DefaultView. The following setting allows the engine to wrap 
            ' datatable with a Syncfusion.Collections.DataTableList to work around 
            ' this bottleneck. It avoids a DefaultView being created for the DataTable.
            ' However, the moment you use a DefaultView yourself for the same DataTable, then
            ' this optimization will have not much effect any more. So only use this
            ' optimization if also no DefaultView is created for the DataTable outside the
            ' grid.
            '
            ' .NET 1.0 and 1.1 are just fine with using DataTable.DefaultView
            '
            Me.gridGroupingControl1.AllowSwapDataViewWithDataTableList = True
        End If
        ' ----------- End of Optimization code -----------------

        Dim ico As New Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"))
        Me.Icon = ico

        '//////////////////////////////////////////////////////////
        ' DataSource
        '//////////////////////////////////////////////////////////
        InitializeDataSet()

        Me.gridGroupingControl1.DataSource = Me.northwindDataSet1.Orders

        '//////////////////////////////////////////////////////////
        Me.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.One

        Dim ordersDescriptor As GridTableDescriptor = Me.gridGroupingControl1.TableDescriptor
        Me.gridGroupingControl1.TableDescriptor.PrimaryKeyColumns.Clear()

        '//////////////////////////////////////////////////////////
        ' Add Unbound field 'ShipVia_CompanyName'
        '//////////////////////////////////////////////////////////
        ordersDescriptor.UnboundFields.Add("ShipVia_CompanyName")

        ' Inform the engine about depency on ShipVia of this field.
        ordersDescriptor.UnboundFields("ShipVia_CompanyName").ReferencedFields = "ShipVia"
        ' When ReferencedFields is set and the engine detects changes to the ShipVia field
        ' it will then automatically also mark the ShipVia_CompanyName field as changed. This
        ' subsequently can affect sort order, group attachment etc.
        ' Callback for calculation of ShipVia_CompanyName field.
        AddHandler ordersDescriptor.QueryValue, AddressOf ordersDescriptor_QueryValue

        ' Hide the field.
        ordersDescriptor.VisibleColumns.Remove("ShipVia_CompanyName")

        ' But use it for grouping.
        ordersDescriptor.GroupedColumns.Add("ShipVia_CompanyName")

        '//////////////////////////////////////////////////////////
        ' Visible Columns
        '//////////////////////////////////////////////////////////
        ' Rearrange visible columns so that "Freight" remains in view.
        ordersDescriptor.VisibleColumns.LoadDefault()
        ordersDescriptor.VisibleColumns.Remove("Freight")
        ordersDescriptor.VisibleColumns.Insert(3, New GridVisibleColumnDescriptor("Freight"))

        ' Change format of freight
        ordersDescriptor.Columns("Freight").Appearance.AnyRecordFieldCell.Format = "F2"
        ordersDescriptor.Columns("Freight").MaxLength = 15

        ordersDescriptor.Columns("CustomerID").MaxLength = 22

        '//////////////////////////////////////////////////////////
        ' Blinking - highlight cells when value increased or 
        ' decreased for a short time
        '//////////////////////////////////////////////////////////
        Me.gridGroupingControl1.BlinkTime = 0 ' optional blinking here (in milliseconde)
        ordersDescriptor.Columns("Freight").AllowBlink = True
        ordersDescriptor.Columns("EmployeeID").AllowBlink = True

        '//////////////////////////////////////////////////////////
        ' Customized caption row
        '//////////////////////////////////////////////////////////
        ' Here you define the summary row that should be used for displaying summaries in caption bar.
        ordersDescriptor.ChildGroupOptions.ShowCaptionSummaryCells = True
        ordersDescriptor.ChildGroupOptions.ShowSummaries = True
        ordersDescriptor.ChildGroupOptions.CaptionSummaryRow = "Caption"

        ' Let's you hide/show the second row in child groups.
        ordersDescriptor.ChildGroupOptions.ShowSummaries = True

        ordersDescriptor.TopLevelGroupOptions.ShowCaptionSummaryCells = False
        ordersDescriptor.ChildGroupOptions.ShowAddNewRecordBeforeDetails = False

        ' Minor customization: Have Caption bar cover some cells.
        AddHandler Me.gridGroupingControl1.TableModel.QueryCoveredRange, AddressOf TableModel_QueryCoveredRange
        captionCoverCols = 2

        ' Make the caption look like a regular cell
        ordersDescriptor.Appearance.GroupCaptionCell.BackColor = Me.gridGroupingControl1.Appearance.RecordFieldCell.BackColor
        ordersDescriptor.Appearance.GroupCaptionCell.Borders.Top = New GridBorder(GridBorderStyle.Standard)
        ordersDescriptor.Appearance.GroupCaptionCell.CellType = "Static"
        ordersDescriptor.TableOptions.CaptionRowHeight = Me.gridGroupingControl1.TableOptions.RecordRowHeight

        '///////////////////////////////////////////////////////////////////////
        ' ManualTotalSummary example code
        '///////////////////////////////////////////////////////////////////////
        ' Totals with delta support for ListChanged events - replacement for built-in summaries of grouping engine.
        AddHandler Me.gridGroupingControl1.QueryCellStyleInfo, AddressOf gridGroupingControl1_QueryCellStyleInfo

        Dim tb As ManualTotalSummaryTable = CType(Me.gridGroupingControl1.Table, ManualTotalSummaryTable)
        tb.TotalSummaries.Add("Freight")
        tb.TotalSummaries.Add("EmployeeID")
        tb.TableDirty = True ' needed after changing TotalSummaries ...

        ' Checking the results of initial total calculations for "Freight"
        Dim cc As Integer = tb.Records.Count ' force initializion
        Dim freightTotalIndex As Integer = tb.TableDescriptor.Fields.IndexOf("Freight")
        Dim tsa As IManualTotalSummaryArraySource = Me.gridGroupingControl1.Table.TopLevelGroup
        Dim tm As ManualTotalSummary = tsa.GetManualTotalSummaryArray()(freightTotalIndex)
        Console.WriteLine("FreightTotal = " + tm.Total.ToString())

        Dim g As Group
        For Each g In Me.gridGroupingControl1.Table.TopLevelGroup.Groups
            tsa = g
            tm = tsa.GetManualTotalSummaryArray()(freightTotalIndex)
            Console.WriteLine(g.ToString() + " FreightTotal = " + tm.Total.ToString())
        Next g

        ' Be notified about changes to SortedColumns collection.
        AddHandler Me.gridGroupingControl1.PropertyChanged, AddressOf gridGroupingControl1_PropertyChanged
    End Sub 'New


    Protected Overrides Sub OnLoad(ByVal e As EventArgs)
        MyBase.OnLoad(e)

        ' Add a button in caption area - clicking this button will start the timer.
        Dim startTimerButton As New Button
        startTimerButton.FlatStyle = FlatStyle.System
        startTimerButton.Bounds = New Rectangle(400, 5, 100, 20)
        startTimerButton.Text = "Start Timer"
        startTimerButton.Visible = True
        Me.Controls.Add(startTimerButton)
        AddHandler startTimerButton.Click, AddressOf startTimerButton_Click
        startTimerButton.BringToFront()

        Dim t As New ToolTip
        t.SetToolTip(startTimerButton, "Click this button to start continous updates. " + vbLf + "Tip: You can also sort by EmployeeID or Freight to check out sort position updates of records.")

        ' Show schema in property grid.
        Dim g As GridGroupingControlSchemaBrowser = New GridGroupingControlSchemaBrowser(Me.gridGroupingControl1)
        g.Show()
    End Sub 'OnLoad


    Sub startTimerButton_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim TESTSPEED As Boolean = False

        If TESTSPEED Then
            Dim timer As Integer = Environment.TickCount
            Dim testCount As Integer = 100
            'using (MeasureTime.Measure("Form1.startTimerButton_Click"))
            If (True) Then
                Dim n As Integer
                For n = 0 To testCount - 1
                    timer_tick(Me, Nothing)
                    Application.DoEvents()
                    Me.gridGroupingControl1.UpdateThrottled()
                Next n
            End If

            Dim s As String = MeasureTime.DumpTimes()
            s += Environment.NewLine
            Dim tc As Integer = Environment.TickCount - timer
            's += "TickCount: " + tc.ToString();
            s += "Average Ticks per timer_tick call: " + (tc / testCount).ToString()
            s += Environment.NewLine

            Me.gridGroupingControl1.Update()
            MessageBox.Show(s)
            '
        Else

            ' Start timer that updates datasource 
            timer = New System.Windows.Forms.Timer
            timer.Interval = 100 ' push in updates every 100 ms. Update 1000 records each time.
            AddHandler timer.Tick, AddressOf timer_tick
            timer.Start()
        End If
    End Sub 'startTimerButton_Click '

    Private rnd As New Random(0)
    Private j As Integer
    Private sortedByFreight As Boolean = False
    Private sortedByEmployeeID As Boolean = False
    Private timer As System.Windows.Forms.Timer


    Sub timer_tick(ByVal sender As Object, ByVal e As EventArgs)
        Dim td As GridTableDescriptor = Me.gridGroupingControl1.TableDescriptor
        Dim tb As ManualTotalSummaryTable = CType(Me.gridGroupingControl1.Table, ManualTotalSummaryTable)
        Dim i As Integer = 0

        Dim m As Syncfusion.Diagnostics.MeasureTime = MeasureTime.Measure("Form1.timer_tick")
        Dim count As Integer = 1000

        If Me.gridGroupingControl1.SortPositionChangedBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate Then
            If sortedByFreight OrElse gridGroupingControl1.TestDeleteRecords OrElse gridGroupingControl1.TestInsertRecords OrElse gridGroupingControl1.TestChangeGroup Then
                count = 200 ' when sort position is changed this is much more demanding, let's do less records then.
            End If
            If sortedByEmployeeID Then
                count = 50 ' each update will cause records being shifted around so let's do even less records. You could also check out InvalidateAll option instead above ...
            End If
        End If
        For i = 0 To count - 1
            Dim dr As ManualTotalSummaries.DataSet1.OrdersRow

            ' Insert Records
            If gridGroupingControl1.TestInsertRecords Then
                If i Mod 10 = 0 Then
                    dr = northwindDataSet1.Orders.NewOrdersRow()
                    dr.CustomerID = i.ToString() + j.ToString()
                    j = j + 1
                    dr.EmployeeID = i
                    dr.Freight = i / 10
                    dr.ShipVia = 0
                    dr.Table.Rows.Add(dr)
                    GoTo ContinueFor1
                End If
            End If

            If northwindDataSet1.Orders.Rows.Count = 0 Then
                Me.gridGroupingControl1.Update()
                Return
            End If

            Dim newIndex As Integer = rnd.Next(northwindDataSet1.Orders.Rows.Count)
            dr = northwindDataSet1.Orders(newIndex)


            ' Delete records
            If gridGroupingControl1.TestDeleteRecords Then
                If i Mod 12 = 0 Then
                    dr.Delete()
                    GoTo ContinueFor1
                End If
            End If

            ' Change records
            ' Freight
            Dim freight As Decimal = System.Convert.ToDecimal(dr.Freight) + Math.Round(System.Convert.ToDecimal(rnd.Next(-100, 100)) / 10000, 2)
            Dim employeeID As Integer = Fix(rnd.NextDouble() * 1000)

            'if (!tb.HasColumnChangeListener)
            '{
            '    // Engine listens to the DataTable.ColumnChanging event, so this code
            '    // is not needed. If you do however have a custom list you can manually
            '    // pass in values as follows or you could also implement the IGroupingColumnChanging
            '    // and raise a ColumnChanging event from within your datasource. 
            '    tb.AddChangedField(new ChangedFieldInfo(td, "Freight", dr.Freight, freight));
            '    tb.AddChangedField(new ChangedFieldInfo(td, "EmployeeID", dr.EmployeeID, employeeID));
            '    Or you could also simply set groupingGrid.AllowCacheRecords = true; // but that is a bit slower
            '}
            dr.BeginEdit()

            Dim oldFreight As Decimal = dr.Freight
            dr.Freight = freight
            dr.EmployeeID = employeeID

            If gridGroupingControl1.TestChangeGroup Then
                ' Change Group Category
                If i = 10 Then
                    tb.AddChangedField(New ChangedFieldInfo(td, "ShipVia", dr.ShipVia, 0))
                    dr.ShipVia = 0
                End If
            End If

            ' fires ListChanged event
            dr.EndEdit()
ContinueFor1:
        Next i

        ' Optionally manually flush changes
        If Me.gridGroupingControl1.UpdateDisplayFrequency = 0 Then
            Me.gridGroupingControl1.Update()
        End If
        m.Dispose()
    End Sub 'timer_tick

#Region "Initialize DataSet"

    Private xmlName As String = "Orders.xml"
    Private msdeAvailable As Boolean = False


    Sub InitializeDataSet()
        If msdeAvailable Then
            ' Initialize the data set
            Me.northwindDataSet1.BeginInit()

            ' Order is important here - first fill tables that are referenced with 
            ' foreign keys, then tables that have references to others.
            Me.sqlDataAdapterOrders.Fill(Me.northwindDataSet1)

            Me.northwindDataSet1.EndInit()

            Me.northwindDataSet1.WriteXml(xmlName)
        Else
            ' Read from a xml file instead. 
            If Not ReadXml(Me.northwindDataSet1, xmlName) Then
                ' If no xml found, try again with MSDE
                msdeAvailable = True
                InitializeDataSet()
            End If
        End If
    End Sub 'InitializeDataSet



    Function ReadXml(ByVal ds As DataSet, ByVal xmlFileName As String) As Boolean
        ' Check both in parent folder and Parent\Data folders.
        Dim xmlDataFileName As String = "Data\" + xmlFileName
        Dim n As Integer
        For n = 0 To 11
            If System.IO.File.Exists(xmlFileName) Then
                ds.ReadXml(xmlFileName)
                Return True
            End If
            If System.IO.File.Exists(xmlDataFileName) Then
                ds.ReadXml(xmlDataFileName)
                Return True
            End If
            xmlFileName = "..\" + xmlFileName
            xmlDataFileName = "..\" + xmlDataFileName
        Next n

        Return False
    End Function 'ReadXml

#End Region


    '/ <summary>
    '/ Clean up any resources being used.
    '/ </summary>
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose

#Region "Windows Form Designer generated code"

    '/ <summary>
    '/ Required method for Designer support - do not modify
    '/ the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Me.northwindDataSet1 = New ManualTotalSummaries.DataSet1
        Me.gridGroupingControl1 = New SampleGridGroupingControl
        Me.sqlSelectCommand2 = New System.Data.SqlClient.SqlCommand
        Me.sqlInsertCommand2 = New System.Data.SqlClient.SqlCommand
        Me.sqlUpdateCommand2 = New System.Data.SqlClient.SqlCommand
        Me.sqlDeleteCommand2 = New System.Data.SqlClient.SqlCommand
        Me.sqlDataAdapterOrders = New System.Data.SqlClient.SqlDataAdapter
        Me.sqlConnection2 = New System.Data.SqlClient.SqlConnection
        CType(Me.northwindDataSet1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.gridGroupingControl1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        ' 
        ' northwindDataSet1
        ' 
        Me.northwindDataSet1.DataSetName = "DataSet1"
        Me.northwindDataSet1.Locale = New System.Globalization.CultureInfo("en-US")
        ' 
        ' gridGroupingControl1
        ' 
        Me.gridGroupingControl1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.gridGroupingControl1.Location = New System.Drawing.Point(0, 0)
        Me.gridGroupingControl1.Name = "gridGroupingControl1"
        Me.gridGroupingControl1.ShowGroupDropArea = True
        Me.gridGroupingControl1.Size = New System.Drawing.Size(690, 664)
        Me.gridGroupingControl1.TabIndex = 0
        ' 
        ' sqlSelectCommand2
        ' 
        Me.sqlSelectCommand2.CommandText = "SELECT OrderID, CustomerID, EmployeeID, OrderDate, RequiredDate, ShippedDate, Shi" + "pVia, Freight, ShipName, ShipAddress, ShipCity, ShipRegion, ShipPostalCode, Ship" + "Country FROM Orders"
        Me.sqlSelectCommand2.Connection = Me.sqlConnection2
        ' 
        ' sqlInsertCommand2
        ' 
        Me.sqlInsertCommand2.CommandText = "INSERT INTO Orders(CustomerID, EmployeeID, OrderDate, RequiredDate, ShippedDate, ShipVia, Freight, ShipName, ShipAddress, ShipCity, ShipRegion, ShipPostalCode, ShipCountry) VALUES (@CustomerID, @EmployeeID, @OrderDate, @RequiredDate, @ShippedDate, @ShipVia, @Freight, @ShipName, @ShipAddress, @ShipCity, @ShipRegion, @ShipPostalCode, @ShipCountry); SELECT OrderID, CustomerID, EmployeeID, OrderDate, RequiredDate, ShippedDate, ShipVia, Freight, ShipName, ShipAddress, ShipCity, ShipRegion, ShipPostalCode, ShipCountry FROM Orders WHERE (OrderID = @@IDENTITY)"
        Me.sqlInsertCommand2.Connection = Me.sqlConnection2
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@CustomerID", System.Data.SqlDbType.NVarChar, 5, "CustomerID"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@EmployeeID", System.Data.SqlDbType.Int, 4, "EmployeeID"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@OrderDate", System.Data.SqlDbType.DateTime, 8, "OrderDate"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@RequiredDate", System.Data.SqlDbType.DateTime, 8, "RequiredDate"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShippedDate", System.Data.SqlDbType.DateTime, 8, "ShippedDate"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipVia", System.Data.SqlDbType.Int, 4, "ShipVia"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Freight", System.Data.SqlDbType.Money, 8, "Freight"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipName", System.Data.SqlDbType.NVarChar, 40, "ShipName"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipAddress", System.Data.SqlDbType.NVarChar, 60, "ShipAddress"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipCity", System.Data.SqlDbType.NVarChar, 15, "ShipCity"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipRegion", System.Data.SqlDbType.NVarChar, 15, "ShipRegion"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipPostalCode", System.Data.SqlDbType.NVarChar, 10, "ShipPostalCode"))
        Me.sqlInsertCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipCountry", System.Data.SqlDbType.NVarChar, 15, "ShipCountry"))
        ' 
        ' sqlUpdateCommand2
        ' 
        Me.sqlUpdateCommand2.CommandText = "UPDATE Orders SET CustomerID = @CustomerID, EmployeeID = @EmployeeID, OrderDate =" + " @OrderDate, RequiredDate = @RequiredDate, ShippedDate = @ShippedDate, ShipVia =" + " @ShipVia, Freight = @Freight, ShipName = @ShipName, ShipAddress = @ShipAddress," + " ShipCity = @ShipCity, ShipRegion = @ShipRegion, ShipPostalCode = @ShipPostalCod" + "e, ShipCountry = @ShipCountry WHERE (OrderID = @Original_OrderID) AND (CustomerI" + "D = @Original_CustomerID OR @Original_CustomerID IS NULL AND CustomerID IS NULL)" + " AND (EmployeeID = @Original_EmployeeID OR @Original_EmployeeID IS NULL AND Empl" + "oyeeID IS NULL) AND (Freight = @Original_Freight OR @Original_Freight IS NULL AN" + "D Freight IS NULL) AND (OrderDate = @Original_OrderDate OR @Original_OrderDate I" + "S NULL AND OrderDate IS NULL) AND (RequiredDate = @Original_RequiredDate OR @Ori" + "ginal_RequiredDate IS NULL AND RequiredDate IS NULL) AND (ShipAddress = @Origina" + "l_ShipAddress OR @Original_ShipAddress IS NULL AND ShipAddress IS NULL) AND (Shi" + "pCity = @Original_ShipCity OR @Original_ShipCity IS NULL AND ShipCity IS NULL) A" + "ND (ShipCountry = @Original_ShipCountry OR @Original_ShipCountry IS NULL AND Shi" + "pCountry IS NULL) AND (ShipName = @Original_ShipName OR @Original_ShipName IS NU" + "LL AND ShipName IS NULL) AND (ShipPostalCode = @Original_ShipPostalCode OR @Orig" + "inal_ShipPostalCode IS NULL AND ShipPostalCode IS NULL) AND (ShipRegion = @Origi" + "nal_ShipRegion OR @Original_ShipRegion IS NULL AND ShipRegion IS NULL) AND (Ship" + "Via = @Original_ShipVia OR @Original_ShipVia IS NULL AND ShipVia IS NULL) AND (S" + "hippedDate = @Original_ShippedDate OR @Original_ShippedDate IS NULL AND ShippedD" + "ate IS NULL); SELECT OrderID, CustomerID, EmployeeID, OrderDate, RequiredDate, S" + "hippedDate, ShipVia, Freight, ShipName, ShipAddress, ShipCity, ShipRegion, ShipP" + "ostalCode, ShipCountry FROM Orders WHERE (OrderID = @OrderID)"
        Me.sqlUpdateCommand2.Connection = Me.sqlConnection2
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@CustomerID", System.Data.SqlDbType.NVarChar, 5, "CustomerID"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@EmployeeID", System.Data.SqlDbType.Int, 4, "EmployeeID"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@OrderDate", System.Data.SqlDbType.DateTime, 8, "OrderDate"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@RequiredDate", System.Data.SqlDbType.DateTime, 8, "RequiredDate"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShippedDate", System.Data.SqlDbType.DateTime, 8, "ShippedDate"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipVia", System.Data.SqlDbType.Int, 4, "ShipVia"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Freight", System.Data.SqlDbType.Money, 8, "Freight"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipName", System.Data.SqlDbType.NVarChar, 40, "ShipName"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipAddress", System.Data.SqlDbType.NVarChar, 60, "ShipAddress"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipCity", System.Data.SqlDbType.NVarChar, 15, "ShipCity"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipRegion", System.Data.SqlDbType.NVarChar, 15, "ShipRegion"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipPostalCode", System.Data.SqlDbType.NVarChar, 10, "ShipPostalCode"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ShipCountry", System.Data.SqlDbType.NVarChar, 15, "ShipCountry"))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_OrderID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "OrderID", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_CustomerID", System.Data.SqlDbType.NVarChar, 5, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "CustomerID", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_EmployeeID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "EmployeeID", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Freight", System.Data.SqlDbType.Money, 8, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "Freight", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_OrderDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "OrderDate", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_RequiredDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "RequiredDate", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipAddress", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipAddress", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipCity", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipCity", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipCountry", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipCountry", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipName", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipPostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipPostalCode", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipRegion", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipRegion", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipVia", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipVia", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShippedDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShippedDate", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlUpdateCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@OrderID", System.Data.SqlDbType.Int, 4, "OrderID"))
        ' 
        ' sqlDeleteCommand2
        ' 
        Me.sqlDeleteCommand2.CommandText = "DELETE FROM Orders WHERE (OrderID = @Original_OrderID) AND (CustomerID = @Original_CustomerID OR @Original_CustomerID IS NULL AND CustomerID IS NULL) AND (EmployeeID = @Original_EmployeeID OR @Original_EmployeeID IS NULL AND EmployeeID IS NULL) AND (Freight = @Original_Freight OR @Original_Freight IS NULL AND Freight IS NULL) AND (OrderDate = @Original_OrderDate OR @Original_OrderDate IS NULL AND OrderDate IS NULL) AND (RequiredDate = @Original_RequiredDate OR @Original_RequiredDate IS NULL AND RequiredDate IS NULL) AND (ShipAddress = @Original_ShipAddress OR @Original_ShipAddress IS NULL AND ShipAddress IS NULL) AND (ShipCity = @Original_ShipCity OR @Original_ShipCity IS NULL AND ShipCity IS NULL) AND (ShipCountry = @Original_ShipCountry OR @Original_ShipCountry IS NULL AND ShipCountry IS NULL) AND (ShipName = @Original_ShipName OR @Original_ShipName IS NULL AND ShipName IS NULL) AND (ShipPostalCode = @Original_ShipPostalCode OR @Original_ShipPostalCode IS NULL AND ShipPostalCode IS NULL) AND (ShipRegion = @Original_ShipRegion OR @Original_ShipRegion IS NULL AND ShipRegion IS NULL) AND (ShipVia = @Original_ShipVia OR @Original_ShipVia IS NULL AND ShipVia IS NULL) AND (ShippedDate = @Original_ShippedDate OR @Original_ShippedDate IS NULL AND ShippedDate IS NULL)"
        Me.sqlDeleteCommand2.Connection = Me.sqlConnection2
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_OrderID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "OrderID", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_CustomerID", System.Data.SqlDbType.NVarChar, 5, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "CustomerID", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_EmployeeID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "EmployeeID", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Freight", System.Data.SqlDbType.Money, 8, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "Freight", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_OrderDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "OrderDate", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_RequiredDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "RequiredDate", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipAddress", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipAddress", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipCity", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipCity", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipCountry", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipCountry", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipName", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipPostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipPostalCode", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipRegion", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipRegion", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShipVia", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShipVia", System.Data.DataRowVersion.Original, Nothing))
        Me.sqlDeleteCommand2.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ShippedDate", System.Data.SqlDbType.DateTime, 8, System.Data.ParameterDirection.Input, False, CType(0, System.Byte), CType(0, System.Byte), "ShippedDate", System.Data.DataRowVersion.Original, Nothing))
        ' 
        ' sqlDataAdapterOrders
        ' 
        Me.sqlDataAdapterOrders.DeleteCommand = Me.sqlDeleteCommand2
        Me.sqlDataAdapterOrders.InsertCommand = Me.sqlInsertCommand2
        Me.sqlDataAdapterOrders.SelectCommand = Me.sqlSelectCommand2
        Me.sqlDataAdapterOrders.TableMappings.AddRange(New System.Data.Common.DataTableMapping() {New System.Data.Common.DataTableMapping("Table", "Orders", New System.Data.Common.DataColumnMapping() {New System.Data.Common.DataColumnMapping("OrderID", "OrderID"), New System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"), New System.Data.Common.DataColumnMapping("EmployeeID", "EmployeeID"), New System.Data.Common.DataColumnMapping("OrderDate", "OrderDate"), New System.Data.Common.DataColumnMapping("RequiredDate", "RequiredDate"), New System.Data.Common.DataColumnMapping("ShippedDate", "ShippedDate"), New System.Data.Common.DataColumnMapping("ShipVia", "ShipVia"), New System.Data.Common.DataColumnMapping("Freight", "Freight"), New System.Data.Common.DataColumnMapping("ShipName", "ShipName"), New System.Data.Common.DataColumnMapping("ShipAddress", "ShipAddress"), New System.Data.Common.DataColumnMapping("ShipCity", "ShipCity"), New System.Data.Common.DataColumnMapping("ShipRegion", "ShipRegion"), New System.Data.Common.DataColumnMapping("ShipPostalCode", "ShipPostalCode"), New System.Data.Common.DataColumnMapping("ShipCountry", "ShipCountry")})})
        Me.sqlDataAdapterOrders.UpdateCommand = Me.sqlUpdateCommand2
        ' 
        ' sqlConnection2
        ' 
        Me.sqlConnection2.ConnectionString = "data source=(local)\NETSDK;initial catalog=Northwind;integrated security=SSPI;per" + "sist security info=True;workstation id=localhost;packet size=4096"
        ' 
        ' 
        ' Form1
        ' 
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(690, 664)
        Me.Controls.Add(gridGroupingControl1)
        Me.Name = "Form1"
        Me.Text = "Syncfusion Essential Grid - ManualTotalSummaries"
        CType(Me.northwindDataSet1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.gridGroupingControl1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
    End Sub 'InitializeComponent 
#End Region


    '/ <summary>
    '/ The main entry point for the application.
    '/ </summary>
    <STAThread()> _
    Shared Sub Main()
        Application.Run(New Form1)
    End Sub 'Main

#Region "Unbound Fields and Covered Ranges"


    Private Sub ordersDescriptor_QueryValue(ByVal sender As Object, ByVal e As FieldValueEventArgs)
        ' This methods maps from the underlying value to a related value
        Dim obj As Object = e.Record.GetValue("ShipVia")
        If Not (obj Is Nothing) AndAlso Not TypeOf obj Is DBNull Then
            Dim shipVia As Integer = Fix(obj)
            Select Case shipVia
                Case 0
                    e.Value = "Zero"
                Case 1
                    e.Value = "One"
                Case 2
                    e.Value = "Two"
                Case 3
                    e.Value = "Three"
            End Select
        End If
    End Sub 'ordersDescriptor_QueryValue

    Private captionCoverCols As Integer


    Private Sub TableModel_QueryCoveredRange(ByVal sender As Object, ByVal e As GridQueryCoveredRangeEventArgs)
        'using (MeasureTime.Measure("TableModel_QueryCoveredRange"))
        Dim thisTable As GridTable = Me.gridGroupingControl1.Table
        If e.RowIndex < thisTable.DisplayElements.Count Then
            Dim el As Element = thisTable.DisplayElements(e.RowIndex)

            Select Case el.Kind
                Case DisplayElementKind.Caption
                    ' Cover some cells of the caption bar (specified with captionCover)
                    Dim gs As IGridGroupOptionsSource = el.ParentGroup '
                    If Not (gs Is Nothing) AndAlso gs.GroupOptions.ShowCaptionSummaryCells Then
                        Dim startCol As Integer = el.GroupLevel + 1
                        If Not gs.GroupOptions.ShowCaptionPlusMinus Then
                            startCol -= 1
                        End If
                        If e.ColIndex >= startCol AndAlso e.ColIndex < startCol + Me.captionCoverCols Then
                            e.Range = GridRangeInfo.Cells(e.RowIndex, startCol, e.RowIndex, startCol + Me.captionCoverCols - 1)
                            e.Handled = True
                        End If
                    End If
                    Exit Select
            End Select
        End If
    End Sub 'TableModel_QueryCoveredRange

#End Region



    '/ <summary>
    '/ Manually fill summary cells with values from ManualTotalSummaries.
    '/ </summary>
    '/ <param name="sender"></param>
    '/ <param name="e"></param>
    Private Sub gridGroupingControl1_QueryCellStyleInfo(ByVal sender As Object, ByVal e As GridTableCellStyleInfoEventArgs)
        Dim el As Element = e.TableCellIdentity.DisplayElement
        Dim table As ManualTotalSummaryTable = el.ParentTable '

        If table Is Nothing Then
            Return
        End If
        'using (MeasureTime.Measure("gridGroupingControl1_QueryCellStyleInfo"))
        If (True) Then
            If Element.IsCaption(el) Then
                If e.Style.TableCellIdentity.ColIndex > 3 Then
                    'e.Style.CellValue = e.Style.TableCellIdentity.ColIndex;
                    ' You need to provide here manually the code to lookup the summaries you want to display here.
                    ' e.TableCellIdentity.Column and e.TableCellIdentity.SummaryColumn will be null
                    ' you can get the column as follows:
                    Dim column As GridColumnDescriptor = Me.gridGroupingControl1.TableModel.GetHeaderColumnDescriptorAt(e.TableCellIdentity.ColIndex)

                    If Not (column Is Nothing) AndAlso table.TotalSummaries.IndexOf(column.MappingName) <> -1 Then
                        Dim index As Integer = column.TableDescriptor.Fields.IndexOf(column.FieldDescriptor)
                        Dim tsa As IManualTotalSummaryArraySource = IIf(TypeOf el Is Group, el, el.ParentGroup)
                        Dim tm As ManualTotalSummary = tsa.GetManualTotalSummaryArray()(index)
                        e.Style.CellValue = tm.Total
                        e.Style.CellValueType = GetType(Double)
                        e.Style.Format = "0.00"
                    End If
                End If ' Using that column you could try and identify the summary that should be displayed in this cell.
            ElseIf TypeOf el Is GridSummaryRow Then
                ' you can get the column as follows:
                Dim column As GridColumnDescriptor = Me.gridGroupingControl1.TableModel.GetHeaderColumnDescriptorAt(e.TableCellIdentity.ColIndex)
                If Not (column Is Nothing) AndAlso table.TotalSummaries.IndexOf(column.MappingName) <> -1 Then
                    Dim index As Integer = column.TableDescriptor.Fields.IndexOf(column.FieldDescriptor)
                    Dim tsa As IManualTotalSummaryArraySource = IIf(TypeOf el Is Group, el, el.ParentGroup) 'TODO: For performance reasons this should be changed to nested IF statements '
                    Dim tm As ManualTotalSummary = tsa.GetManualTotalSummaryArray()(index)
                    e.Style.CellValue = tm.Total
                    e.Style.CellValueType = GetType(Double)
                    e.Style.Format = "0.00"
                End If
            End If ' Using that column you could try and identify the summary that should be displayed in this cell.
        End If
    End Sub 'gridGroupingControl1_QueryCellStyleInfo


    Private Sub gridGroupingControl1_PropertyChanged(ByVal sender As Object, ByVal e As DescriptorPropertyChangedEventArgs)
        Dim gcc As GridGroupingControl = CType(sender, GridGroupingControl)
        If e.PropertyName = "TableDescriptor" Then
            Dim tableDescriptor As TableDescriptor = gcc.TableDescriptor
            e = CType(e.Inner, DescriptorPropertyChangedEventArgs)

            If e.PropertyName = "Relations" Then
                e = e.GetNestedChildTableDescriptorEvent(tableDescriptor)
            End If
            Select Case e.PropertyName
                Case "SortedColumns"
                    sortedByFreight = tableDescriptor.SortedColumns.Contains("Freight")
                    sortedByEmployeeID = tableDescriptor.SortedColumns.Contains("EmployeeID")
                    Exit Select
            End Select
        End If
    End Sub 'gridGroupingControl1_PropertyChanged
End Class 'Form1




Public Class SampleGridGroupingControl
    Inherits GridGroupingControl

    Public Sub New()
    End Sub 'New

    Private _testDeleteRecords As Boolean = False
    Private _testInsertRecords As Boolean = False
    Private _testChangeGroup As Boolean = False
    Private maxCount As Integer = 1000
    Private timerInterval As Integer = 100


    <Category("Tests")> _
    Public Property TestDeleteRecords() As Boolean
        Get
            Return _testDeleteRecords
        End Get
        Set(ByVal Value As Boolean)
            _testDeleteRecords = Value
        End Set
    End Property

    <Category("Tests")> _
    Public Property TestInsertRecords() As Boolean
        Get
            Return _testInsertRecords
        End Get
        Set(ByVal Value As Boolean)
            _testInsertRecords = Value
        End Set
    End Property

    <Category("Tests")> _
    Public Property TestChangeGroup() As Boolean
        Get
            Return _testChangeGroup
        End Get
        Set(ByVal Value As Boolean)
            _testChangeGroup = Value
        End Set
    End Property
End Class 'SampleGridGroupingControl